;	ADC_0 = 
;	ADC_1 =  ()
;	ADC_2 = 
;
;











.include 	"m32def.inc"		;  ATMega32


.def	Temp=R16
.def	Temp1=R17
.def	Temp2=R18
.def	Temp3=R19
.def	Temp4=R20			;   /  SREG
.def	Temp5=R21 			; 
.def	Temp6=R22			; 		
.def	Temp7=R23			; 		
.def	Temp8=R24
.def	Temp9=R25



;******************************************************************************
; ******
;******************************************************************************

.dseg					; 

ADC_len: .byte 2			;  2    =       



ch_count: .byte 1			;     (    0,1,2,3 ) -    

curr_ch: .byte 1			;     (    0,1,2 )

ch_phase: .byte 1			;   (     300 )

pack_len: .byte 2			;    



;******************************************************************************
; 
;******************************************************************************

.equ	ADC_ADMUX= (0<<MUX0)

.equ	ADC_ADCSRA= (1<<ADEN)|(1<<ADSC)|(7<<ADPS0)

.EQU	Constanta_1= 0x3E8 			; 1000

.EQU	pause_len= 0x258 			; 600

.EQU	general_len= 0x9C40			;    ppm (  " ") ( 20000  )





;******************************************************************************
; ******
;******************************************************************************
;  
;******************************************************************************

.cseg	


		

.org 0					; External Pin, Power-on Reset, Brown-out Reset, and Watchdog Reset
rjmp RESET				



.org   OC1Aaddr				; Timer/Counter1 Compare Match A
rjmp OCR1A_COMP




;	.org ADCCaddr			; ADC Conversion Complete (    -    !!! )
;	rjmp ADC_Conversion




.org INT_VECTORS_SIZE			;   


;******************************************************************************
; 
;******************************************************************************

reset:					;  



	cli				;    



	ldi Temp, low(RAMEND)		;  
	out SPL, Temp
	ldi Temp, high(RAMEND)
	out SPH, Temp



	
	ldi Temp,0b00000000		;   "A" (0-, 1-)
	out DDRA,Temp			; 0000000x - ""  PA0
					; 000000x0 - ""  PA1
					; 00000x00 - ""  PA2
				



	ldi Temp,0b00100000		;   "D" (0-, 1-)
	out DDRD,Temp			; 0000000 - ""  
					 
		
			

	ldi Temp,0b00000000		;     "D"
	out PortD,Temp			; 





;	RCALL	LCD_INIT		;  



;   *******************************************************************************


	ldi Temp, 0			;     = 0
	STS ch_count, Temp		;



	ldi Temp, 0			;    = 0
	STS curr_ch, Temp		;


	ldi Temp, 0			;   = 0
	STS ch_phase, Temp		;




					;    
	LDI XL, low(pack_len)		;   "X"   "pack_len" (  16-  )
	LDI XH, high(pack_len)		;


	LDI temp, 0			;   
	ST X+, temp			;    Temp      "X" 
	LDI temp, 0			;  
	ST X+, temp			;    Temp      "X" 





; *******************************************************************************************

	ldi Temp,(0<<MUX0)		
	out ADMUX,Temp	
					; REFS0=0 /   5V /
					; ADLAR=0 /   ( 8     2    )
					; MUX0=0  /    ADC0 (PA0)
					; MUX1=0 
					; MUX2=0 
					; MUX3=0 		
					; MUX4=0

	

	ldi Temp, (1<<ADEN)|(1<<ADSC)|(7<<ADPS0)
	out ADCSRA,Temp
					; ADEN=1  /  
					; ADSC=1  /   
					; ADATE=0 /   
					; ADIF=0  /      
					; ADIE=0  /    
					; ADPS2=1
					; ADPS1=1
					; ADPS0=1 /   1/128 ( 16  / 128 = 125  )



;	ldi Temp, (0<<ADTS0)
;	out SFIOR,Temp


					; PUD=0 /   ,     //  
					; PSR10=0 /   _1 //  
					; PSR2=0 /   _2 //  
					; ACME=0  /       //   .
					; ADTS2=0
					; ADTS1=0
					; ADTS0=0 /    
					; (       ) //   .






; ************************************************************************************************************



	ldi Temp,(1<<COM1A1)|(1<<COM1A0)|(1<<FOC1A)	;    "OC1A"
	out TCCR1A,Temp					;     OC1A ( _1 )!!!

							; COM1A1 /   OC1A //    
							; COM1A0 /   OC1A // (   )
							; COM1B1 /   OC1B 
							; COM1B0 /   OC1B 
							; FOC1A=1 /     OC1A
							; FOC1B=0 /     OC1B // 
							; WGM11=0 / 
							; WGM10=0 / 


	ldi Temp,(0<<COM1A1)|(1<<COM1A0)|(0<<FOC1A)	;    OC1A
	out TCCR1A,Temp					;      OC1A

							; COM1A1 /   OC1A
							; COM1A0 /   OC1A //   
							; COM1B1 /   OC1B 
							; COM1B0 /   OC1B
							; FOC1A=0 /     OC1A // 
							; FOC1B=0 /     OC1B // 
							; WGM11=0 / 
							; WGM10=0 / 


	ldi Temp,(1<<WGM12)|(1<<cs11)			;   "CTC"  
	out TCCR1B,Temp					;     = CK 1:8 
							;   !!!

							; ICNC1=0 / 
							; ICES1=0 / 
							; WGM13=0
							; WGM12=1 /   "CTC"
							; CS12
							; CS11=1 /   = CK 1:8 (16/8=2) 1   = 0,5 
							; CS10 



	ldi Temp,(1<<OCIE1A)				;    
	out TIMSK,Temp



 	ldi Temp, 0xFF					;   0xFFFF,      ;)
	OUT OCR1AH, Temp				;     
	OUT OCR1AL, Temp 				; 
    


	ldi Temp,0					;   
	out TCNT1H,Temp
	out TCNT1L,Temp




	sei						;   
	


;*******************************************************************************************************************************
;  
;*******************************************************************************************************************************

Main:							;  



	Rjmp Main





;*******************************************************************************************************************************
;    
;*******************************************************************************************************************************

OCR1A_COMP:



	in temp4,SREG				;  "SREG"/////////////////////////////////////////////////////
	push temp4



;   ***********************************************************************


	LDS Temp, ch_phase			;   


	cpi Temp, 1				;  _1 ?
	brne transmit_pause_s			;  _0
	rjmp transmit_momentum			;  _1


transmit_pause_s: 

	rjmp transmit_pause			; " "

;***********************************************************************************************
;   *****************************************************************************
;***********************************************************************************************


		
transmit_momentum:				;  _1


	LDI Temp, 0
	STS ch_phase, Temp			;   /     



	LDS Temp, ch_count			;     
	cpi Temp, 3				;   ?
	brne transmit_chanal			; ,   
	rjmp transmit_clock_pulse		;  



;***********************************************************************************************
;  ********************************************************************************

transmit_chanal:				;  


	LDS Temp, ch_count			;     
	inc Temp				;     
	STS ch_count, Temp			;     




	ldi YL, low(ADC_len)			;   "Y"   "ADC_len"
	ldi YH, High(ADC_len)			;

	ld XL, Y+				;   "X"      "Y"
	ld XH, Y+				;
	




; +1000 

	ldi Temp, Low(Constanta_1)
	ldi Temp1, high(Constanta_1)

	add XL, Temp				;  +1000
	adc XH, Temp1				;





; *2

	LSL XL					;    16-   (    )
	ROL XH					;



	mov YL, XL				;    "X"  "Y"...
	mov YH, XH





; -600 

	ldi Temp, Low(pause_len)
	ldi Temp1, high(pause_len)


	SUB XL, Temp				; -600  ( )
	SBC XH, Temp1				;



	OUT OCR1AH, XH				;     
	OUT OCR1AL, XL 				; 



;        



	lds YL, pack_len			;  ( )   "Y"   "pack_len" 
	lds YH, pack_len+1			; 


	add YL, XL				;        
	adc YH, XH				;



	STS pack_len, YL			;    "pack_len"  
	STS pack_len+1, YH			; 


	rjmp OCR1A_COMP_EXIT			; 


;*************************************************************************************************
;  **************************************************************************


transmit_clock_pulse:				;  


	lds YL, pack_len			;  ( )   "Y"    "pack_len" 
	lds YH, pack_len+1			; 


						
	LDI XL, low(general_len)		;   "X"  20
	LDI XH, high(general_len)		;


	SUB XL, YL				; 20  (   ) -    =   
	SBC XH, YH				;




	ldi Temp, Low(pause_len)
	ldi Temp1, high(pause_len)



	SUB XL, Temp				; -600  ( )
	SBC XH, Temp1				;



	OUT OCR1AH, XH				;     
	OUT OCR1AL, XL 				; 









	ldi Temp, 0				;     
	STS ch_count, Temp			;


						;    
	LDI XL, low(pack_len)			;   "X"   "pack_len" (  16-  )
	LDI XH, high(pack_len)			;


	LDI temp, 0				;   
	ST X+, temp				;    Temp      "X" 
	LDI temp, 0				;  
	ST X+, temp				;    Temp      "X" 



	rjmp OCR1A_COMP_EXIT			; 



;*************************************************************************************************
;  **********************************************************************************
;*************************************************************************************************


transmit_pause:					;  _0 ( 300  = 600   )


	LDI Temp, 1
	STS ch_phase, Temp			;   /     



 	ldi XL, low(pause_len)			; 600   (        )
 	ldi XH, high(pause_len)			; 


	OUT OCR1AH, XH				;     
	OUT OCR1AL, XL 				; 




	LDi XL, low(ADC_len)			;   "X"   "ADC_len" (  16-  )
	LDi XH, high(ADC_len)


	IN temp, ADCL				;     
	ST X+, temp				;    Temp      "Z" 
	IN temp, ADCH				;       
	ST X+, temp				;


;      ******************************************************************



	LDS Temp, curr_ch			;    



	cpi temp, 2				;    _2 ?
	breq currch_2				;

	cpi Temp, 1				;    _1 ?
	breq currch_1				;




currch_0:					;  _0

	LDI Temp, 1				;       1
	STS curr_ch, Temp			; 
	rjmp setting_ADS			;




currch_1:					;  _1

	LDI Temp, 2				;       2
	STS curr_ch, Temp			;
	rjmp setting_ADS			;




currch_2:					;  _2

	LDI Temp, 0				;       0
	STS curr_ch, Temp			;
	rjmp setting_ADS			;




;      ************************************************************* 
          
setting_ADS:

	LDI Temp, ADC_ADMUX			;   ADMUX
	LDS Temp1, curr_ch			;    () 

	OR Temp, Temp1      			;       (  "" )
	OUT ADMUX, Temp				;   



;     
   
	LDI R16, ADC_ADCSRA
	OUT ADCSRA, R16




	rjmp OCR1A_COMP_EXIT			; 



;***************************************************************************************************
;   *******************************************************************************


OCR1A_COMP_EXIT:				; 
   
	pop temp4				;  "SREG" ////////////////////////////////////////////////////
	out SREG, temp4



	RETI					;   


;*******************************************************************************************************************************
; ***
;*******************************************************************************************************************************



